﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using WorkWithDatabase.ViewModels;

namespace WorkWithDatabase.Models
{
    public partial class Teacher
    {
        public string FIO
        {
            get
            {
                return Name + " " + Surname + " " + Patronymic;
            }
        }

        public string EmailTeacher
        {
            get
            {
                return "Почта: " + Email;
            }
        }

        public string GenderTeacher
        {
            get
            {
                return "Пол: " + GenderNavigation.TitleGender;
            }
        }

        public string PhoneTeacher
        {
            get
            {
                if (Phone == null || Phone == "")
                {
                    return "Телефон: отсутствует";
                }
                return "Телефон: " + Phone;
            }
        }

        public string ExperienceTeacher
        {
            get
            {
                if (Experience < 12)
                {
                    return "Стаж работы: " + Experience + " месяц(а,ев)";
                }
                else if (Experience == 12 || Experience % 12 == 0)
                {
                    return "Стаж работы: " + Experience / 12 + " год/а(лет)";
                }
                else if (Experience > 12 && Experience % 12 != 0)
                {
                    int? year = Experience / 12;
                    int? month = Experience % 12;

                    return "Стаж работы: " + year + " год/а(лет) " + month + " месяц/а/ев";
                }
                return "";
            }
        }
        public string hours
        {
            get
            {
                int? sumH = 0;
                foreach (var item in TeacherCourses)
                {
                    sumH += item.CourseNavigation.Hours;
                }
                return $"Курсы в общем объёме {sumH} часов:";
            }
        }

        public int? hoursCourse
        {
            get
            {
                int? sumH = 0;
                foreach (var item in TeacherCourses)
                {
                    sumH += item.CourseNavigation.Hours;
                }
                return sumH;
            }
        }
    }
}