﻿using System;
using System.Collections.Generic;
using Microsoft.EntityFrameworkCore;

namespace WorkWithDatabase.Models;

public partial class _43pGoncharovaContext : DbContext
{
    public _43pGoncharovaContext()
    {
    }

    public _43pGoncharovaContext(DbContextOptions<_43pGoncharovaContext> options)
        : base(options)
    {
    }

    public virtual DbSet<Course> Courses { get; set; }

    public virtual DbSet<Gender> Genders { get; set; }

    public virtual DbSet<Subject> Subjects { get; set; }

    public virtual DbSet<Teacher> Teachers { get; set; }

    public virtual DbSet<TeacherCourse> TeacherCourses { get; set; }

    public virtual DbSet<TeacherSubject> TeacherSubjects { get; set; }

    protected override void OnConfiguring(DbContextOptionsBuilder optionsBuilder)
#warning To protect potentially sensitive information in your connection string, you should move it out of source code. You can avoid scaffolding the connection string by using the Name= syntax to read it from configuration - see https://go.microsoft.com/fwlink/?linkid=2131148. For more guidance on storing connection strings, see https://go.microsoft.com/fwlink/?LinkId=723263.
        => optionsBuilder.UseNpgsql("Host=edu.pg.ngknn.local;Port=5432;Database=43P_Goncharova;Username=43P;Password=444444");

    protected override void OnModelCreating(ModelBuilder modelBuilder)
    {
        modelBuilder.Entity<Course>(entity =>
        {
            entity.HasKey(e => e.IdCourse).HasName("course_pkey");

            entity.ToTable("course");

            entity.Property(e => e.IdCourse).HasColumnName("id_course");
            entity.Property(e => e.Hours).HasColumnName("hours");
            entity.Property(e => e.TitleCourse)
                .HasMaxLength(200)
                .HasColumnName("title_course");
        });

        modelBuilder.Entity<Gender>(entity =>
        {
            entity.HasKey(e => e.IdGender).HasName("gender_pkey");

            entity.ToTable("gender");

            entity.Property(e => e.IdGender).HasColumnName("id_gender");
            entity.Property(e => e.TitleGender)
                .HasMaxLength(50)
                .HasColumnName("title_gender");
        });

        modelBuilder.Entity<Subject>(entity =>
        {
            entity.HasKey(e => e.IdSubject).HasName("subject_pkey");

            entity.ToTable("subject");

            entity.Property(e => e.IdSubject).HasColumnName("id_subject");
            entity.Property(e => e.TitleSubject)
                .HasMaxLength(200)
                .HasColumnName("title_subject");
        });

        modelBuilder.Entity<Teacher>(entity =>
        {
            entity.HasKey(e => e.IdTeacher).HasName("teacher_pkey");

            entity.ToTable("teacher");

            entity.Property(e => e.IdTeacher).HasColumnName("id_teacher");
            entity.Property(e => e.Birthday)
                .HasColumnType("timestamp without time zone")
                .HasColumnName("birthday");
            entity.Property(e => e.Email)
                .HasMaxLength(200)
                .HasColumnName("email");
            entity.Property(e => e.Experience).HasColumnName("experience");
            entity.Property(e => e.Gender)
                .ValueGeneratedOnAdd()
                .HasColumnName("gender");
            entity.Property(e => e.Name)
                .HasMaxLength(200)
                .HasColumnName("name");
            entity.Property(e => e.Patronymic)
                .HasMaxLength(200)
                .HasColumnName("patronymic");
            entity.Property(e => e.Phone)
                .HasMaxLength(100)
                .HasColumnName("phone");
            entity.Property(e => e.Surname)
                .HasMaxLength(200)
                .HasColumnName("surname");

            entity.HasOne(d => d.GenderNavigation).WithMany(p => p.Teachers)
                .HasForeignKey(d => d.Gender)
                .OnDelete(DeleteBehavior.ClientSetNull)
                .HasConstraintName("teacher_gender_fkey");
        });

        modelBuilder.Entity<TeacherCourse>(entity =>
        {
            entity.HasKey(e => e.IdTc).HasName("teacher_course_pkey");

            entity.ToTable("teacher_course");

            entity.Property(e => e.IdTc).HasColumnName("id_tc");
            entity.Property(e => e.Course)
                .ValueGeneratedOnAdd()
                .HasColumnName("course");
            entity.Property(e => e.Teacher)
                .ValueGeneratedOnAdd()
                .HasColumnName("teacher");

            entity.HasOne(d => d.CourseNavigation).WithMany(p => p.TeacherCourses)
                .HasForeignKey(d => d.Course)
                .HasConstraintName("teacher_course_course_fkey");

            entity.HasOne(d => d.TeacherNavigation).WithMany(p => p.TeacherCourses)
                .HasForeignKey(d => d.Teacher)
                .HasConstraintName("teacher_course_teacher_fkey");
        });

        modelBuilder.Entity<TeacherSubject>(entity =>
        {
            entity.HasKey(e => e.IdTs).HasName("teacher_subject_pkey");

            entity.ToTable("teacher_subject");

            entity.Property(e => e.IdTs).HasColumnName("id_ts");
            entity.Property(e => e.Subject)
                .ValueGeneratedOnAdd()
                .HasColumnName("subject");
            entity.Property(e => e.Teacher)
                .ValueGeneratedOnAdd()
                .HasColumnName("teacher");

            entity.HasOne(d => d.SubjectNavigation).WithMany(p => p.TeacherSubjects)
                .HasForeignKey(d => d.Subject)
                .HasConstraintName("teacher_subject_subject_fkey");

            entity.HasOne(d => d.TeacherNavigation).WithMany(p => p.TeacherSubjects)
                .HasForeignKey(d => d.Teacher)
                .HasConstraintName("teacher_subject_teacher_fkey");
        });

        OnModelCreatingPartial(modelBuilder);
    }

    partial void OnModelCreatingPartial(ModelBuilder modelBuilder);
}
